//+------------------------------------------------------------------+
//|                                                        Trade.mq4 |
//|                                             Komgrit Sungkhaphong |
//|                               http://iamforextrader.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Komgrit Sungkhaphong"
#property link      "http://iamforextrader.blogspot.com"

//+------------------------------------------------------------------+
//| My function                                                      |
//+------------------------------------------------------------------+
// int MyCalculator(int value,int value2)
//   {
//    return(value+value2);
//   }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|Trade functions                                                     |
//+------------------------------------------------------------------+
/*
double StopPoint()
{
   return(MarketInfo(Symbol(),MODE_STOPLEVEL)*Point);
}
*/
/*
Function: Trade(..)
   Require global vairable
   Order_Type
   MN =  Magic Number
   LotSize
   Price 
   Stop
   Target
   Expire
   Comment_text
   
*/

// Trade.Buy(symbol,MAGIC,0.1,stop,target,comment);
// Trade.Sell(symbol,MAGIC,0.1,stop,target,comment);
int Trade_Buy(string _symbol,int MN,double Lot,double stop=0,double tp=0,string _comment="")
{
   RefreshRates();
   double _ask;
   _ask=MarketInfo(_symbol,MODE_ASK);
   return(Trade(OP_BUY,_symbol,MN,Lot,_ask,_comment,stop,tp));
}
int Trade_Sell(string _symbol,int MN,double Lot,double stop=0,double tp=0,string _comment="")
{
   RefreshRates();
   double _bid;
   _bid=MarketInfo(_symbol,MODE_BID);
   return(Trade(OP_SELL,_symbol,MN,Lot,_bid,_comment,stop,tp));
}

int Trade
   (int Order_Type,
   string _symbol,
   int MN,
   double LotSize, 
   double Price,
   string Comment_Text="",     
   double price.stop=0, 
   double price.tp=0, 
   datetime Expire=0,
   int Slippage=3,
   color color_order=CLR_NONE
   )
   {
      int ticket_number;
      //int price.stop;
      //int price.tp;
      
      //Normalizing numbers
      LotSize=LegalizeLotSize(LotSize);
      price.tp=NormalizeDouble(price.tp,Digits);
      price.stop=NormalizeDouble(price.stop,Digits);
      //send order command
      ticket_number=OrderSend(_symbol,Order_Type,LotSize,Price,Slippage,price.stop,price.tp,Comment_Text,MN,0,color_order);
      wait_server();
      if(OrderSelect(ticket_number,SELECT_BY_TICKET)==true)
      {

         return(ticket_number);  
      }
      else
      {
         return(-1);
         //Print("error: Cannot send order, code:",GetLastError());
      }   
   }

//Function: NormalizeLotSize(lot)
// Returns = NormalizeDouble(lot, ..lot step decimal.. )
double NormalizeLotSize(double LotSize)
   {
      int LotStep;
      switch(MarketInfo(Symbol(), MODE_LOTSTEP))
      {
         case 0.01 : LotStep = 2; break;
         case  0.1 : LotStep = 1; break;
         case    1 : LotStep = 0; break;
      }
      LotSize=NormalizeDouble(LotSize,LotStep);
      return(LotSize);
   }
double LegalizeLotSize(double lots)
{   
   if(lots<MarketInfo(Symbol(),MODE_MINLOT)) lots=MarketInfo(Symbol(),MODE_MINLOT);
   else if(lots>MarketInfo(Symbol(),MODE_MAXLOT)) lots=MarketInfo(Symbol(),MODE_MAXLOT);
   else
   {
      lots=NormalizeLotSize(lots);
   }
   
   
   return(lots);
}

bool ModifySL(int ticket, double stoploss)
{
   while(IsTradeContextBusy()) Sleep(100);
   if(OrderSelect(ticket,SELECT_BY_TICKET)==true)  Print("ModifySL:SELECT ORDER #"+ticket);
   if(OrderCloseTime()==0)  Print("ModifySL:ORDER #"+ticket+" is live!");
   if(OrderModify(ticket,OrderOpenPrice(),stoploss,OrderTakeProfit(),0,CLR_NONE)==true)
   {
      return(true);   
   }
   else
   {
      string _bid,_ask,_sl,context;
      _bid=DoubleToStr(Bid,Digits);
      _ask=DoubleToStr(Ask,Digits);
      _sl=DoubleToStr(stoploss,Digits);
      //context=_bid+"/"+_ask+"/"+_sl;
      //ErrorLog("ModifySL()","trying to modify stop loss (b/a/sl)-->"+context);
   }
}
//+------------------------------------------------------------------+

double NowBid(string $)
{
   RefreshRates();
   return(MarketInfo($,MODE_BID));
}
double NowAsk(string $)
{
   RefreshRates();
   return(MarketInfo($,MODE_ASK));
}

double NowSpread(string $)
{
   return(NowAsk($)-NowBid($));
}

void wait_server()
{
   while(IsTradeContextBusy())
   {
      Sleep(20);
   }
}  